/*
 A simple program that
 implement newton iterative scheme
*/

#include <iostream>
#include <cmath>
using namespace std ; // for the moment magic ``keyword''

double
f( double x) {
  return x*x-2 ;
}

double
df( double x) {
  return 2*x ;
}

// user function implementing newton scheme
int 
newton( double & x,           // initial guess and returned value
        double   tolerance,   // tolerance for stopping criteria
        int      max_iter ) { // maximum iterations allowed

  // cout.precision(10) ;
  for ( int i=0 ; i < max_iter ; ++i ) {
    double h = f(x)/df(x) ;
	x -= h ; // x = x - h
	// cout << "x[" << i << "] = " << x << "  h = " << h << '\n' ;
	if ( abs(h) < tolerance ) return 0 ; // found solution
  }
  return 1 ; // failed to converge
}


int
main( /* no argument for the moment */ ) {
  double x, tol = 1e-8 ;
  cout << "Initial guess x0 = " ;
  cin >> x ; 
  int ok = newton( x, tol, 100 ) ;
  if ( ok == 0 ) {
    cout << "Newton converged with value = " << x << "\n" ;
  } else {
    cout << "Newton do not converge\n" ;  
  }
  return 0 ; // return 0 to the OS
}
